* Action routines			v0.00   1987  J.R.Oakley  QJUMP
*					v1.00   2017  W.Lenerz (correct handling of selkey 242)
	section prog
*
	include 'dev8_keys_wwork'
	include 'dev8_keys_wstatus'
	include 'dev8_keys_wman'
	include 'dev8_keys_qdos_pt'
	include 'dev8_mac_assert'
*
	xdef	tv_nolac
	xdef	tv_rtlac
	xdef	tv_rrlac
	xdef	tv_noaac
	xdef	tv_rtaac
	xdef	tv_rraac
	xdef	tv_ehit
*
*	Action routines for loose menu items
*
tv_rrlac
	move.w	wwl_item(a3),d3 	; get item number
	move.b	#wsi.mkav,ws_litem(a1,d3.w) ; set it back to available
	moveq	#-1,d3			; and selectively
	jsr	wm.ldraw(a2)		; re-draw it
tv_rtlac
	moveq	#pt..null,d3		; return null event
	bra.s	tvl_srtp		; and return parameters
*
tv_nolac
	moveq	#0,d3			; no event, normally
tvl_srtp
	move.w	wwl_item(a3),0(a6,a5.l) ; set item number
	move.w	#-1,2(a6,a5.l)		; and "not sub-window"
	cmp.w	#' ',d2 		; was it a keystroke?
	blt.s	tvl_chke		; no, see if we need to make an event
	moveq	#pt..do,d3		; yes, force DO
tvl_chke
	move.b	wwl_skey(a3),d0 	; get item's select key
*
*	Exit all action routines via here
*
tvx_csky
	cmp.b	#1,d0			; less than minimum event?
	bls.s	tvx_exev		; yes, not an event
	cmp.b	#' ',d0 		; greater than maximum event?
	bgt.s	tvx_exev		; no, also not an event
	moveq	#14,d3
	add.b	d0,d3			; set event number
	; **  the above will set d3.b to 0 if the selkey was 242
	bne.s	tvx_exev		; ***** 1.00
	bset	#31,d3			; ***** 1.00 : if 0 set flag
tvx_exev
	cmp.w	#pt..do,d4		; was there an important event?
	bgt.s	tvx_exok		; yes, don't change it
	blt.s	tvx_sete		; hit or none, always changed
	tst.w	d3			; other event?
	beq.s	tvx_exok		; no, keep the DO
	cmp.w	#pt..null,d3		; yes, null?
	beq.s	tvx_exok		; yes, DO is more important
tvx_sete
	cmp.l	#$80000000,d3		; ***** 1.00  ; flag set?
	bne.s	tvx_d4			; ***** 1.00  ; no
	moveq	#14,d3			; ***** 1.00  ; yes, reset correct event
tvx_d4	move.l	d3,d4			; set required event
tvx_exok
	moveq	#0,d0			; no error
	rts
*
*	Action routines for application sub-window items
*
tv_rraac
	move.b	#wsi.mkav,0(a1,d2.w)	; set item back to available
	moveq	#-1,d3			; and selectively
	jsr	wm.mdraw(a2)		; re-draw it
tv_rtaac
	moveq	#pt..null,d3		; return null event
	bra.s	tva_srtp		; and return parameters
*
tv_noaac
	moveq	#0,d3			; no event, normally
tva_srtp
	move.w	d2,0(a6,a5.l)		; set item number
	move.l	ww_wstat(a4),a1 	; point to status area
	move.w	wsp_swnr(a1),2(a6,a5.l) ; and set sub-window number 
*
	move.w	d1,d0			; get row number
	assert	wwm.rlen,8
	ext.l	d0
	asl.l	#3,d0			; offset in row list is this
	add.l	wwa_rowl(a3),d0 	; row entry is here
	move.l	d0,a3			; get...
	move.l	wwm_rows(a3),a3 	; ...row start address
	move.l	d1,d0
	swap	d0			; get column number
	mulu	#wwm.olen,d0		; thus offset in row
	add.l	d0,a3			; thus item
	move.b	wwm_skey(a3),d0 	; get item's select key
	bra	tvx_csky		; and exit checking it
*
*	Hit routine for application sub-window
*
tv_ehit
	tst.w	d4			; any event?
	beq.s	tve_nein		; no
	bset	d4,wsp_weve(a1) 	; yes, set it
tve_nein
	cmp.l	wsp_xpos(a1),d7 	; has the pointer really moved?
	bne.s	tve_sete		; yup, return an event
	moveq	#pt.kystk+pt.kyprs,d0	; check for...
	and.b	wsp_peve(a1),d0 	; ...keystroke/press
	beq.s	tve_noev		; none, don't return
tve_sete
	bset	#pt..null,wsp_weve(a1)	; set null event
tve_noev
	move.w	wsp_swnr(a1),2(a6,a5.l) ; sub-window number 
	move.w	wsp_kstr(a1),0(a6,a5.l) ; and keystroke/keypress in "item"
	moveq	#-1,d3
	moveq	#0,d0
	rts
*
	end
