* Change an item			v0.00   Aug 1987  J.R.Oakley  QJUMP
*
        section prog
*
        include 'dev8_mac_assert'
        include 'dev8_keys_err'
        include 'dev8_keys_wwork'
        include 'dev8_keys_wstatus'
        include 'dev8_keys_wman'
        include 'dev8_keys_qdos_pt'
        include 'dev1_asm_qptr_keys'
*
        xref    bem_chpn
        xref    bem_ruhp
        xref    bem_relr
        xref    bed_gwmv
        xref    let_long
*
        xdef    be_chitm
        xdef    be_chptr
        xdef    be_chwin
*
*       Change a loose, information or sub-window item 
*
be_chitm
        sub.w   #2*8,a5		; ignore last parameters for now
        move.w  ca.gtlin,a2
        jsr     (a2)		; get the rest as long integers
        bne     bec_exit		; ...oops
        subq.w  #4,d3		; were there four?
        bne     bec_exbp		; no, wrong
*
        move.l  a5,a3
        lea     8(a3),a5		; next parameter
        move.w  ca.gtstr,a2
        jsr     (a2)		; is a string
        bne     bec_exit
        moveq   #-1,d4		; assume no new select key
        move.w  0(a6,a1.l),d0 	; string is this long
        beq.s   bec_nsky		; null string, no change
        move.b  2(a6,a1.l),d4
        ext.w   d4
bec_nsky
        addq.w  #3,d0		; length to unwind
        bclr    #0,d0
        add.w   d0,a1		; skip back past string
*
        move.l  0(a6,a1.l),a4 	; this is the menu
        move.l  4(a6,a1.l),d1 	; and this the sub-window
        bpl.s   bec_appw		; positive is an application sub-window
        addq.l  #2,d1		; -1 is a loose menu item
        bgt.s   bec_loos		; it is
*
*       Modify an information item
*
        neg.w   d1			; number was negative
        moveq   #-1,d4		; not allowed to set select key
        cmp.w   ww_ninfo(a4),d1	; are there that many info windows?
        bhs     bec_exor		; no
        mulu    #wwi.elen,d1		; yes, it's offset this far in...
        add.l   ww_pinfo(a4),d1	; ...this table
        move.l  d1,a0		; point to window
        move.l  wwi_pobl(a0),a0	; and thus to object list
        lea     mol_hfre-mol.hdrl(a0),a2 ; keep free space pointer
        move.l  8(a6,a1.l),d1 	; the item we want
        moveq   #wwo.elen,d2		; and the spacings
        sub.w   d2,a0
bec_scan
        add.w   d2,a0
        tst.w   wwo_xsiz(a0)		; end of information list?
        dbmi    d1,bec_scan		; loop if not
        bmi.s   bec_exor		; fell off end before finding object
        lea     wwo_pobj(a0),a4	; point to object
        lea     wwo_type(a0),a0	; and to type
        bra.s   bec_fixo		; and fix it
*
*       Modify a loose menu item
*
bec_loos
        move.l  8(a6,a1.l),d1 	; item number
        cmp.w   ww_nlitm(a4),d1	; is it allowed?
        bhs.s   bec_exor		; no
        mulu    #wwl.elen,d1		; yes, this is the offset
        move.l  ww_plitm(a4),a0	; in this list
        lea     mol_hfre-mol.hdrl-wwa.elen(a0),a2 ; heap
        add.l   d1,a0
        lea     wwl_pobj(a0),a4	; point to object
        lea     wwl_type(a0),a0	; and type
        bra.s   bec_fixo
*
*       Modify a menu sub-window item
*
bec_appw
        bsr.s   bec_fapp		; find application sub-window
        bne.s   bec_exit		; karang
        move.l  wwa_rowl(a4),d0	; objects are in the row list
        beq.s   bec_exbp		; no such animal
        move.l  d0,a0
        lea     mol_hfre-mol.hdrl-rwl.hdrl(a0),a2
        move.l  -rwl.hdrl+rwl_obtb(a0),a0 ; point to object table pointer
        move.l  8(a6,a1.l),d1 	  ; item to fix
        cmp.w   mol_numo(a0),d1	  ; enuff items?
        bhs.s   bec_exor		  ; no
        mulu    #wwm.olen,d1
        add.l   d1,a0		; offset of entry for this item
        add.w   #mol.hdrl+wwa.elen,a0	; plus offset to start of table
        lea     wwm_pobj(a0),a4	; object to fix
        lea     wwm_type(a0),a0	; its current type
        bra.s   bec_fixo
*
bec_exor
        moveq   #err.orng,d0
        bra.s   bec_exit
bec_exbp
        moveq   #err.ipar,d0
bec_exit
        rts
*
*       Find application sub-window
*
*       Registers:
*	      Entry		        Exit
*       D0			        error code
*       D1      sub-window number	        smashed
*       A4      working defn		        sub-window defn
*
bec_fapp
        cmp.w   ww_nappl(a4),d1	; are there enough sub-windows?
        bhs.s   bec_exor		; no, quel wallie
        move.l  ww_pappl(a4),a4	; yes, here's the list
        add.w   d1,d1
        add.w   d1,d1		; entries are long
        move.l  0(a4,d1.l),a4 	; point to sub-window
        moveq   #0,d0
        rts
*
*       Fix an object
*
*       Registers:
*	      Entry		        Exit
*       D4      new selkey or -1
*       A0      type byte
*       A1      RI stack pointer
*       A2      user heap free list
*       A4      object pointer
*       A5      NT "end" (before new object)
*
fixreg  reg     a0/a2/a5
stk_a0  equ     $00
stk_a2  equ     $04
stk_a5  equ     $08
*
bec_fixo
        movem.l fixreg,-(sp)
*
        tst.w   d4			 ; new select key?
        bmi.s   bef_rcur		 ; no, remove current object
        assert  wwm_skey-wwm_type,wwl_skey-wwl_type
        move.b  d4,wwm_skey-wwm_type(a0) ; yes, fill it in 
*
bef_rcur
        assert  text,0
        tst.b   (a0)		; is the current object text?
        bgt.s   bef_nort		; no, don't have heap to return
        move.l  a2,a5		; heap is here
        move.l  (a4),d0		; string is here
        beq.s   bef_nort		; no it isn't
        move.l  d0,a0
        jsr     bem_ruhp(pc)		; return string space
*
bef_nort
        move.l  stk_a0(sp),a0 	; restore type pointer
        move.l  12(a6,a1.l),d0	; type of new item
        cmp.b   #-1,d0
        bne.s   bef_chtp		; explicit, check it
        move.b  (a0),d0		; same as old
        bra.s   bef_prmp
bef_chtp
        blt.s   bef_us		; ... underscore
        assert  text,sprite-2,blob-4,patt-6
        cmp.b   #patt,d0		; in range?
        bls.s   bef_tfil		; yep, fill it in
        bra.s   bef_exbp		; nope
bef_us
******** this should be asr.b same as in  bem_giob!
        asr.l   #1,d0		; true underscore posn
*********
bef_tfil
        move.b  d0,(a0)

bef_prmp
        move.l  stk_a5(sp),a3 	; point to object parameter
        lea     8(a3),a5		; just one
        assert  text,0 
        bgt.s   bef_gptr		; not text, get longword pointer
*
        move.w  ca.gtstr,a2
        jsr     (a2)		; object is string, get it
        bne.s   bef_exit		; zonk
        clr.l   (a4)		; zap old pointer
        exg     a0,a4
        move.l  stk_a2(sp),a5 	; point to user heap
        jsr     bem_relr(pc)		; and copy string into it
        bne.s   bef_exit		; failed
        move.l  a1,(a0)		; fill in new pointer
        bra.s   bef_exit
*
bef_gptr
        move.w  ca.gtlin,a2
        jsr     (a2)		; just get a longword
        bne.s   bef_exit		; boing
        move.l  0(a6,a1.l),(a4)	; and fill it in
*
bef_exok
        moveq   #0,d0
bef_exit
        movem.l (sp)+,fixreg
        rts
bef_exbp
        moveq   #err.ipar,d0
        bra.s   bef_exit
*
*       Set pointer sprite
*
be_chptr
        move.w  ca.gtlin,a2
        jsr     (a2)		; get parameters
        bne.s   bep_exit		; clunk
        subq.w  #3,d3
        bne     bec_exbp		; click?
        move.l  0(a6,a1.l),a4 	; the menu to change
        move.l  4(a6,a1.l),d1 	; the sub-window number
        bmi.s   bep_smwp		; -1 is main window
        bsr     bec_fapp		; find sub-window
        bne.s   bep_exit		; so don't
        move.l  8(a6,a1.l),wwa_pspr(a4) ; new sprite
        bra.s   bep_exok
bep_smwp
        move.l  8(a6,a1.l),ww_psprt(a4) ; new sprite
bep_exok
        moveq   #0,d0
bep_exit
        rts
bep_exbp
        moveq   #err.ipar,d0
        bra.s   bep_exit
*
*       Change a window: if a pair of co-ordinates is given
*       then a change size is done, otherwise it's a position change.
*
be_chwin
        moveq   #1,d7		; assume one parameter
        jsr     bem_chpn(pc)
        bgt.s   bep_exbp		; none, must be wrong
        move.w  d0,d7		; keep number
*
        lea     8(a3),a5
        move.w  ca.gtlin,a2		; get parameter
        jsr     (a2)
        bne     bep_exit		; whoopsie
        move.l  a5,a3
        move.l  0(a6,a1.l),d0 	; point to window definition
        bclr    #0,d0		; must be even
        bne     bep_exbp		; wrong
        move.l  d0,a4
        move.l  ww_wstat(a4),a1	; status area
        cmp.l   ws_work(a1),a4	; does it look reasonable?
        bne     bep_exbp		; no
*
        cmp.w   #1,d7		; one parameter => move
        beq.s   bew_move		; one, just move
        cmp.w   #3,d7		; three => change size
        bne.s   bep_exbp		; boing
*
        bset    #pt..wsiz,wsp_weve(a1)	; set change size bit
        bclr    #pt..wmov,wsp_weve(a1)	; and clear move, just in case
        bsr.s   bew_chng		; and do change
        move.l  d1,d6		; keep result safe
        swap    d1
        ext.l   d1
        move.l  bv_rip(a6),a1 	; restore RI stack pointer
        move.l  d1,0(a6,a1.l) 	; put x move on RI stack
        jsr     let_long(pc)		; assign to variable
        bne     bep_exit		; whoops
        addq.l  #8,a3		; next variable
        subq.l  #4,a1		; unwind stack again
        ext.l   d6			; make Y long
        move.l  d6,0(a6,a1.l) 	; push
        jsr     let_long(pc)		; and pop
        bra     bep_exit		; done
*
*       Come here to move a window
*
bew_move
        bset    #pt..wmov,wsp_weve(a1)	; set move bit
bew_chng	      
        move.l  ww_chid(a4),a0	; get... 
        jsr     bed_gwmv(pc)		; ...window manager vector
        bne.s   bew_exit		; whoops
        jsr     wm.chwin(a2)		; and do a window change
bew_exit
        rts
*
        end
