* Get attributes from arrays		v0.00   Aug 1987  J.R.Oakley  QJUMP
*
        section prog
*
        include 'dev8_keys_err'
        include 'dev1_asm_qptr_keys'
*
        xref    bem_glin
        xref    bem_cfar
        xref    bem_ciar
*
        xdef    bem_cpya
        xdef    bem_cpyi
        xdef    bem_gwat
        xdef    bem_swat
        xdef    bem_giat
        xdef    bem_siat
*
*       Copy item attributes from one place to another, changing
*       relative pointers as they go
*
*       Registers:
*	      Entry		        Exit
*       A0      dest (CPYI)		        preserved
*       A1      source		        preserved
*       A2      dest (CPYA)		        preserved
*
cpyreg  reg     d0/d1/a0-a2
bem_cpyi
        movem.l cpyreg,-(sp)
        moveq   #1,d0
        move.l  a0,a2
        bra.s   bem_cpen
bem_cpya
        movem.l cpyreg,-(sp)
        moveq   #3,d0
bem_cpen
        move.l  (a1)+,(a2)+		; copy current item attribute 
        bra.s   bem_cpye
bem_cpyl
        move.l  (a1)+,(a2)+		; copy colours
        move.l  (a1)+,(a2)+		; and blob
        move.l  (a1)+,(a2)+		; and pattern
bem_cpye
        dbra    d0,bem_cpyl		; for all three states
        movem.l (sp)+,cpyreg
        rts
*
*       Set up to get some window attributes, expected to be in a
*       1x3 integer array.
*
*       Registers:
*	      Entry		        Exit
*       D0			        error code
*       D1			        index increment
*       A0			        first element
*       A3      parameter in NT	        preserved
*
bem_swat
        jsr     bem_ciar(pc)		; check we have an integer array
        bne.s   bes_exbp		; we don't
        cmp.w   #1,4(a6,a0.l) 	; one dimension
        bne.s   bes_exbp		; not one
        cmp.w   #3,6(a6,a0.l) 	; of max index 3
        bne.s   bes_exbp		; not 3 either
        move.w  8(a6,a0.l),d1 	; get index multiplier
        add.w   d1,d1		; items are a word long
        move.l  0(a6,a0.l),a0 	; point to values
        add.l   bv_vvbas(a6),a0
bes_exok
        moveq   #0,d0
bes_exit
        rts
bes_exbp
        moveq   #err.ipar,d0
        bra.s   bes_exit
*
*       Copy window attributes from an integer array
*
*       Registers:
*	      Entry		        Exit
*       D1      index increment	        preserved
*       A0      first element 	        preserved
*       A2      start of attribute record       preserved
*
gwatreg reg     a0/a2
bem_gwat
        movem.l gwatreg,-(sp)
        moveq   #3,d0		; four attributes
bes_gwal
        move.w  0(a6,a0.l),(a2)+	; copy one
        add.w   d1,a0		; point to next
        dbra    d0,bes_gwal
*
        movem.l (sp)+,gwatreg
        rts
*
*       Get item attributes
*
*       Registers:
*	      Entry		        Exit
*       D1      row increment-4*colinc	        preserved
*       D2      column increment	        preserved
*       A0      pointer to 3x3 fp array parm    preserved
*       A2      where to put attributes         preserved
*
giatreg reg     d1-d4/a0-a2/a4
bem_giat
        movem.l giatreg,-(sp)
        move.l  a2,a4
*
        jsr     bem_glin(pc)		; get a long integer
        bne.s   beg_exer
        move.w  d3,(a4)+		; that's current border width
        jsr     bem_glin(pc)
        bne.s   beg_exer
        move.w  d3,(a4)+		; get current border colour
        add.l   d2,a0		; only two parameters in this row
        add.l   d2,a0		; so step on to end of row
        moveq   #3,d4		; three statuses to cope with
        bra.s   bem_gate
bem_gatl
        jsr     bem_glin(pc)
        bne.s   beg_exer
        move.w  d3,(a4)+		; get background colour
        jsr     bem_glin(pc)
        bne.s   beg_exer
        move.w  d3,(a4)+		; get ink colour
        jsr     bem_glin(pc)
        bne.s   beg_exer
        move.l  d3,(a4)+		; get blob pointer
        jsr     bem_glin(pc)
        bne.s   beg_exer
        move.l  d3,(a4)+		; get pattern pointer
bem_gate
        add.l   d1,a0		; step on to start of next row
        dbra    d4,bem_gatl
        moveq   #0,d0
beg_exer
        movem.l (sp)+,giatreg
        rts
beg_exbp
        moveq   #err.ipar,d0
        bra.s   beg_exer
*
*       Process a parameter with a view to extracting item attributes
*       from it.  It should be a 3x3 f.p. array.
*
*       Registers:
*	      Entry		        Exit
*       D0			        error
*       D1			        increment from row end to start 
*       D2			        column increment 
*       A0			        first element
*       A3      parameter in NT	        preserved
*
bem_siat
        jsr     bem_cfar(pc)		; check it's an f.p. array
        bne     bes_exbp		; ...oops, it isn't
        cmp.w   #2,4(a6,a0.l) 	; two dimensional
        bne     bes_exbp		; ...oops
        moveq   #3,d1
        cmp.w   6(a6,a0.l),d1 	; and three...
        bne     bes_exbp
        cmp.w   10(a6,a0.l),d1	; ...by three elements
        bne     bes_exbp
*
        move.w  8(a6,a0.l),d1 	; get first index multiplier
        move.w  12(a6,a0.l),d2	; and second
        move.l  0(a6,a0.l),a0 	; and pointer to base
        add.l   bv_vvbas(a6),a0	; that's VVBAS relative
        mulu    #6,d1
        mulu    #6,d2		; f.p. numbers are 6 bytes long
        move.l  d2,d0		; column increment
        add.l   d0,d0
        add.l   d0,d0		; there are four columns
        sub.l   d0,d1		; so this far from end of row to start
        bra     bes_exok
*
        end
