* Information makings		v0.00   Aug 1987  J.R.Oakley  QJUMP 
*
	section prog
*
	include 'dev8_keys_qdos_sms'
	include 'dev8_keys_err'
	include 'dev8_mac_assert'
	include 'dev8_keys_wwork'
	include 'dev1_asm_qptr_keys'
*
	xref	ut_lfla1
	xref	ut_retfp
*
	xref	bem_chpn
	xref	bem_gdat
	xref	bem_gsiz
	xref	bem_achp
	xref	bem_gxyw
	xref	bem_glng
	xref	bem_giob
	xref	bem_rchp
	xref	bem_gipt
	xref	bem_sia2
	xref	bem_sri6
*
	xdef	be_mkiot
	xdef	be_mkiwt
*
*	Make a loose item table.
*
be_mkiot
	move.l	a5,d5			; keep pointer to end of parameters
	moveq	#4,d7			; we need more than 4 parameters
	jsr	bem_chpn(pc)
	sub.l	a5,a5			; flag no heap yet
	bge.s	bem_exbp		; not enough parameters...
*
	moveq	#wwo.elen,d6		; size per entry
	moveq	#mol.hdrl+2,d0		; space for item attributes+end flag
	jsr	bem_gdat(pc)		; get some heap
	bne.s	bem_exit		; ...oops
	move.w	d7,mol_numo(a5) 	; keep number of items in table
*
*	Fill in the table from the arrays passed
*
otbs	equ	mol.hdrl
*
	lea	wwo_xsiz+otbs(a5),a4	; fill in sizes
	jsr	bem_gxyw(pc)		; get x/y words
	bne.s	bem_exit		; ...oops
*
	lea	wwo_xorg+otbs(a5),a4	; fill in origins
	addq.l	#8,a3		
	jsr	bem_gxyw(pc)
	bne.s	bem_exit
*
	lea	wwo_comb+otbs(a5),a4	; fill in pointer to combined item
	addq.l	#8,a3
	jsr	bem_glng(pc)		; get some long words
	bne.s	bem_exit
*
	lea	wwo_type+otbs(a5),a4	; fill in type/object
	lea	mol_hfre(a5),a5 	; user heap for strings
	addq.l	#8,a3
	jsr	bem_giob(pc)
	lea	-mol_hfre(a5),a5
	bne.s	bem_exit
*
	move.w	#-1,wwo_xsiz-wwo_type(a4) ; mark end of table
	moveq	#0,d0
bem_exit
	tst.l	d0			; OK?
	beq.s	bem_rtad		; yes
*
	move.l	d0,-(sp)
	move.l	a5,d0			; is there any heap?
	beq.s	bem_nrhp		; no
	move.l	d0,a0
	jsr	bem_rchp(pc)		; yes, unlink and return it
bem_nrhp
	move.l	(sp)+,d0
	rts
bem_exbp
	moveq	#err.ipar,d0
	bra.s	bem_exit
*
bem_rtad
	jsr	bem_sri6(pc)		; ensure there's stack space
	move.l	a5,d1			; set D1 to base of table
	addq.l	#6,bv_rip(a6)		; point to current TOS
	jsr	ut_lfla1(pc)		; and push D1 (floated) onto RI stack
	jmp	ut_retfp(pc)		; and return with 
	page
*
*	Make an information sub-window table
*
be_mkiwt
	moveq	#3,d7
	jsr	bem_chpn(pc)		; exactly three parameters?
	sub.l	a5,a5			; (no heap)
	bne	bem_exbp		; nope
*
	jsr	bem_gsiz(pc)		; get size of integer array
	bne	bem_exit		; dud
	move.w	d1,d7			; and keep it
	beq	bem_exbp		; unless it's 0...
*
	mulu	#wwi.elen,d1		; size of table
	addq.l	#6,d1			; space for size/#obs/terminator
	jsr	bem_achp(pc)		; get it
	bne	bem_exit
	move.l	a0,a5			; and keep it
	move.w	d7,(a5) 		; and number of items
*
*	Fill in from arrays
*
wtbs	equ	4
*
	assert	wwi_xsiz,wwi_ysiz-2,wwi_xorg-4,wwi_yorg-6
	lea	wwi_xsiz+wtbs(a5),a1
	bsr.s	bew_gatt		; get window definitions
	bne	bem_exit		; failed
*
	addq.l	#8,a3
	assert	wwa_clfg,wwa_shdd-1,wwa_borw-2,wwa_borc-4,wwa_papr-6
	lea	wwi_watt+wtbs(a5),a1
	bsr.s	bew_gatt		; get attributes
	bne	bem_exit
*
	moveq	#wwi.elen,d6		; table spacing
	lea	wwi_pobl+wtbs(a5),a4	; fill in pointers to object lists
	addq.l	#8,a3
	jsr	bem_gipt(pc)		; get some pointers
	bne	bem_exit
	move.w	d4,2(a5)		; fill in number of objects
*
	move.w	#-1,-wwi_pobl(a4)	; end of table flag
	moveq	#0,d0			; OK
	bra.s	bem_exit
*
*	Get n sets of four words from an array into four consecutive
*	words in the table
*
bew_gatt
	moveq	#3,d3			; must be an nx4...
	jsr	bem_sia2(pc)		; ...2-d integer array
	bne.s	bew_exit		; ...oops
	bra.s	bew_swde		; and set window definitions
bew_swdl
	moveq	#3,d0			; four words
bew_swil
	move.w	0(a6,a0.l),(a1)+	; fill one in
	add.w	d2,a0			; next element
	dbra	d0,bew_swil
	add.w	#wwi.elen-8,a1		; next window, less amount advanced
	add.w	d1,a0			; next row of array
bew_swde
	dbra	d3,bew_swdl
	moveq	#0,d0
bew_exit
	rts
*
	end
