* Set up sprites			v0.00   1987  J.R.Oakley  QJUMP
*
*	SPSET addr,xorg,yorg,mode,patt$()	    set up complete sprite 
*	SPHDR addr[,xsiz,ysiz,xorg,yorg,mode][,next]  set up header
*	SPLIN addr,lin%,patt$		    set up line of sprite
*	MKPAT addr,buffer			    make pattern from save
*
*	There must be enough memory at addr for the sprite definition
*
	section prog
*
	include 'dev8_keys_qdos_pt'
	include 'dev1_asm_qptr_keys'
	include 'dev8_keys_err'
*
	xref	ut_lfloat
*
	xdef	let_long
*
	xdef	be_spset
	xdef	be_sphdr
	xdef	be_splin
	xdef	be_mkpat
*

pto_adpt  equ	2			; ***0.01***
be_spset
	subq.l	#8,a5			; get all but last parameter
	move.w	ca.gtlin,a2
	jsr	(a2)			; get long integers
	bne	bes_exit		; ...oops
	subq.w	#4,d3			; must be exactly four
	bne	bes_exbp		; ...oops
*
	move.l	0(a6,a1.l),d0		; point to area where sprite goes
	bclr	#0,d0			; must be even
	bne	bes_exbp		; whoops
	move.l	d0,a0
	move.w	6(a6,a1.l),pto_xorg(a0) ; fill in x origin
	move.w	10(a6,a1.l),pto_yorg(a0); and y origin
	move.w	14(a6,a1.l),d0		; get mode
	moveq	#0,d1			; assume mode 4
	and.w	#%011111011,d0		; modes 0,4 or 512 will do
	beq.s	bes_sfrm		; mode 4, set form
	moveq	#1,d1			; mode 8
bes_sfrm
	or.w	#$100,d1
	move.w	d1,pto_form(a0) 	; fill in mode
	clr.w	pto_adpt(a0)		; no adaption
*
*	Now check to see if last parameter is OK
*
	cmp.b	#3,0(a6,a5.l)		; is the last parameter an array?
	bne	bes_exbp		; no, wrong
	moveq	#$f,d0
	and.b	1(a6,a5.l),d0		; what is type of array?
	moveq	#-1,d7			; assume string, negative flag
	cmp.b	#1,d0			; must be 0 or 1
	bhi.s	bes_exbp		; it isn't
	beq.s	bes_fdsc		; it's a string, find descriptor
	moveq	#0,d7			; positive flag for substring
*
bes_fdsc
	move.l	bv_vvbas(a6),a1 	; find variables area
	move.l	4(a6,a5.l),a2		; array descriptor is here
	add.l	a1,a2			; relative to base
*
	cmp.w	#2,4(a6,a2.l)		; is the array two-dimensional?
	bgt.s	bes_exbp		; no, more, wrong
	blt.s	bes_1dim		; no, 1-d is special case
	move.w	6(a6,a2.l),d6		; yes, get y size
	addq.w	#1,d6			; that's one more than max index
	move.w	10(a6,a2.l),d5		; get x size (characters)
	move.w	8(a6,a2.l),d4		; index multiplier
	bra.s	bes_sysz		; and set size
bes_1dim
	move.w	6(a6,a2.l),d5		; x size is first (only) dimension
	move.w	4(a6,a2.l),d4		; this is the index multiplier
	moveq	#1,d6			; y size is 1
bes_sysz
	move.w	d6,pto_ysiz(a0) 	; fill in y size in sprite
	swap	d6
	sub.w	d5,d4			; amount to add at end of row
	tst.l	d7			; is it a substring?
	bpl.s	bes_sxsz		; yes, set x size
	subq.w	#2,d4			; no, allow for length in row increment
bes_sxsz
	moveq	#1,d0
	and.w	pto_form(a0),d0 	; get mode, 0 or 1
	addq.w	#1,d0			; ... becomes 1 or 2
	move.l	d0,d3			; keep that
	move.w	d5,pto_xsiz(a0) 	; fill in x size, unscaled for now
	mulu	d5,d0			; true width is this
*
*	Find out how far to offset mask, and fill in relative pointers
*
	bsr	bes_fptr
*
	lea	24(a0),a3		; point to pattern...
	lea	16(a0,d0.l),a4		; ...and mask
	move.l	0(a6,a2.l),a2		; offset of (sub)string data...
	add.l	a1,a2			; ...in VV area
	lea	m4tab(pc),a1		; assume mode 4
	cmp.w	#1,d3			; is it?
	beq.s	bes_doit		; yes
	lea	m8tab(pc),a1		; no, use mode 8 table
bes_doit
	bsr.s	bes_sspr
*
bes_exok
	mulu	pto_xsiz(a0),d3 ; scale x size by mode
	move.w	d3,pto_xsiz(a0) ; and fill it in again
	moveq	#0,d0
bes_exit
	rts
bes_exbp
	moveq	#err.ipar,d0
	bra.s	bes_exit
*
*
*	At this point we should have
*
*	D3.l	pixels per character (1 or 2)
*	D4.w	increment to next string
*	D5.w	pixels per line (to nearest 16)
*	D6.l	number of lines | X
*	D7.l	+ve if reading from sub-string
*	A0	sprite header
*	A1	pointer to mask table
*	A2	pointer to string
*	A3	sprite pattern
*	A4	sprite mask
*
bes_sspr
	bra.s	bes_nxln
bes_linl
	move.w	(a1),d2 	; initial mask
bes_wrdl
	sub.l	d3,d6		; one character fewer
	tst.w	d6			; any pixels left?
	bmi.s	bes_eoln		; no, end of this line
*
	moveq	#' ',d1 	; unreal pixels are transparent
	subq.w	#1,d7		; any real pixels left?
	bmi.s	bes_blpx		; no, use transparent
	move.b	0(a6,a2.l),d1	; yes, get a character
	or.b	#$20,d1 	; lowercase it
	addq.l	#1,a2		; and point to next one
bes_blpx
	move.w	d2,d0		; get mask
	not.w	d0
	and.w	d0,(a3) 	; and blank existing pattern...
	and.w	d0,(a4) 	; ...and mask
	moveq	#8,d0		; there are 8 valid characters
bes_fvch
	cmp.b	vctab(pc,d0.w),d1	; look for character in table
	dbeq	d0,bes_fvch
	bne.s	bes_rtse		; ...oops
	add.w	d0,d0		; get offset in colour table
	beq.s	bes_nxpx		; it's transparent, no more work to do
	move.w	2(a1,d0.w),d0	; get colour pattern
	and.w	d2,d0		; mask out all but current pixel
	or.w	d0,(a3) 	; set pattern
	or.w	d2,(a4) 	; and mask
bes_nxpx
	lsr.w	d3,d2		; shift mask
	bcc.s	bes_wrdl		; not finished this word yet
	cmpm.w	(a3)+,(a4)+		; increment pattern and mask pointers
	bra.s	bes_linl		; and do next bit of line
*
bes_eoln
	add.w	d4,a2		; go to start of next line
bes_nxln
	clr.w	d6
	moveq	#0,d0		; if we stop now there's no error
	tst.l	d6			; any more lines left?
	beq.s	bes_rtss		; no, done then
	move.w	d5,d6		; yes, number of pixels to set in line
	move.w	pto_xsiz(a0),d7 ; a line has this many characters
	tst.l	d7			; is this a substring?
	bpl.s	bes_linl		; yes, just do the line
	move.w	0(a6,a2.l),d7	; no, a string that's this long
	addq.l	#2,a2		; and its characters are here
	bra.s	bes_linl
bes_rtse
	moveq	#err.ipar,d0
bes_rtss
	rts
*
vctab
	dc.b	' aurmgcyw'
*
	ds.w	0
m4tab
	dc.w	$8080
	dc.w	$1234
	dc.w	$0000,$0000
	dc.w	$00ff,$00ff
	dc.w	$ff00,$ff00
	dc.w	$ffff,$ffff
m8tab
	dc.w	$c0c0
	dc.w	$abcd
	dc.w	$0000,$0055
	dc.w	$00aa,$00ff
	dc.w	$aa00,$aa55
	dc.w	$aaaa,$aaff
	dc.w	0
*
*	Fill in relative pointers in header: on entry D0=width, A0=header
*
bes_fptr
	add.w	#$f,d0		; get width...
	and.w	#$fff0,d0		; ...to nearest 16 pixels... 
	move.w	d0,d5		; (always set this many pixels in a row)
	asr.w	#2,d0		; ...thus nearest long word
	mulu	pto_ysiz(a0),d0 ; size of a pattern/mask for the sprite
	addq.l	#8,d0
	move.l	d0,pto_mask(a0) ; offset from mask pointer to mask
	move.l	#12,pto_cpat(a0)	; from pattern pointer to pattern
	clr.l	pto_nobj(a0)		; no next sprite
	rts
*
*	Set up a sprite's header: the form, size and origin are filled
*	in from the parameters, together with an optional link to
*	the next sprite for multi-mode sprites.
*
be_sphdr
	move.w	ca.gtlin,a2
	jsr	(a2)		; get some long integers
	bne.s	beh_exit		; whoops
*
	move.l	0(a6,a1.l),d0	; point to space
	bclr	#0,d0		; even?
	bne.s	beh_exbp		; nope, wrong
	move.l	d0,a0
*
	move.l	4(a6,a1.l),d0	; possible NEXT pointer
	subq.w	#2,d3		; if only two parameters
	beq.s	beh_snxt		; it is
	subq.w	#4,d3		; otherwise we need at least 6
	bmi.s	beh_exbp		; which in our case...
*
	move.w	6(a6,a1.l),pto_xsiz(a0) ; fill in size and origin
	move.w	10(a6,a1.l),pto_ysiz(a0)
	move.w	14(a6,a1.l),pto_xorg(a0)
	move.w	18(a6,a1.l),pto_yorg(a0)
*
	move.w	22(a6,a1.l),d0	; get mode
	moveq	#0,d1		; assume mode 4
	and.w	#%011111011,d0	; modes 0,4 or 512 will do
	beq.s	beh_sfrm		; mode 4, set form
	moveq	#1,d1		; mode 8
beh_sfrm
	or.w	#$100,d1
	move.w	d1,pto_form(a0) ; fill in mode
	clr.w	pto_adpt(a0)		; no adaption
*
	move.w	pto_xsiz(a0),d0
	bsr	bes_fptr		; fill in relative pointers
*
	subq.w	#1,d3		; one more parameter?
	bmi.s	beh_exok		; no, finished
	bgt.s	beh_exbp		; no, too many
	move.l	24(a6,a1.l),d0	; yes, pointer to next sprite
beh_snxt
	move.l	d0,d1		; is the pointer zero?
	beq.s	beh_snob		; yes, just set it
	bclr	#0,d0		; must be even
	bne.s	beh_exbp		; wrong
	moveq	#-pto_nobj,d1
	sub.l	a0,d1		; -address of link
	add.l	d0,d1		; makes relative address
beh_snob
	move.l	d1,pto_nobj(a0) ; fill it in
beh_exok
	moveq	#0,d0
beh_exit
	rts
beh_exbp
	moveq	#err.ipar,d0
	bra.s	beh_exit
*
*	Fill in a line of a sprite definition
*
linereg reg	a3
stk_a3	equ	$00
be_splin
	movem.l linereg,-(sp)
*
	subq.l	#8,a5		; get all but last parameter...
	move.w	ca.gtlin,a2		; as long integers
	jsr	(a2)
	bne	bel_exit		; ...boing
	subq.w	#2,d3		; two of them
	bne	bel_exbp		; not two, bother
	move.l	a1,a4
*
	move.l	a5,a3		; point to last parameter
	lea	8(a3),a5		; exactly
	move.w	ca.gtstr,a2
	jsr	(a2)		; get it as a string
	bne.s	bel_exbp
	move.l	a1,a2		; keep pointer to it
	move.l	a4,a1		; restore pointer to integers
	move.l	a1,bv_rip(a6)
*
	move.l	0(a6,a1.l),d0	; point to sprite header
	bclr	#0,d0
	bne.s	bel_exbp		; not even, bomb
	move.l	d0,a0		; keep it
*
	move.l	pto_cpat(a0),a3 ; point to pattern...
	move.l	pto_mask(a0),a4 ; ...and mask
	lea	pto_cpat(a0,a3.l),a3	; make them...
	lea	pto_mask(a0,a4.l),a4	; ...absolute
*
	move.w	pto_xsiz(a0),d0 ; get size...
	add.w	#$f,d0
	and.w	#$fff0,d0		; ...rounded up
	move.w	d0,d5		; keep it
	asr.w	#2,d0
	move.w	6(a6,a1.l),d1	; line we want to set
	cmp.w	pto_ysiz(a0),d1 ; off end?
	bhs.s	bel_exor		; yes, bomb
	mulu	d1,d0		; offset to line we want to set
	add.l	d0,a3
	add.l	d0,a4		; adjust pattern and mask
*
	lea	m4tab(pc),a1		; assume...
	moveq	#1,d3		; ...a mode 4 sprite
	btst	#0,pto_form+1(a0)	; is it?
	beq.s	bel_stln		; yes
	lea	m8tab(pc),a1		; no, set up for mode 8
	moveq	#2,d3
bel_stln
	moveq	#-1,d7		; real string
	moveq	#1,d6
	swap	d6			; just one line
	bsr	bes_sspr
	bne.s	bel_exit		; whoops
*
*	Now increment the line counter
*
	move.l	bv_rip(a6),a1	; restore RI stack pointer
	addq.l	#4,a1		; line count is here
	addq.l	#1,0(a6,a1.l)	; update it
	move.l	stk_a3(sp),a3
	addq.l	#8,a3		; point to variable
	bsr.s	let_long		; assign a long integer to it
*
bel_exit
	movem.l (sp)+,linereg
	rts
bel_exbp
	moveq	#err.ipar,d0
	bra.s	bel_exit
bel_exor
	moveq	#err.orng,d0
	bra.s	bel_exit
*
*	Assign a long word from the RI stack to a variable of
*	any type.
*
*	Registers:
*	      Entry			Exit
*	D0				error code
*	D1-D5				smashed
*	A0				smashed
*	A1	top of RI stack 	+4
*	A2				smashed
*	A3	NT entry to assign to		preserved
*	A4				smashed
*
let_long
	moveq	#$f,d0
	and.w	0(a6,a3.l),d0	; get parameter type
	subq.w	#2,d0		; and check it
	beq.s	float		; type 2, float the number
	bmi.s	string		; type 1, convert to string
	addq.w	#2,a1		; type 3, assign short integer
	bsr.s	letit
	addq.w	#2,a1
let_exit
	move.l	a1,bv_rip(a6)	; pop item
	tst.l	d0
	rts
float
	move.l	0(a6,a1.l),d1	; get long integer
	addq.l	#4,a1		; and pop it
	jsr	ut_lfloat(pc)	; float D1 back onto RI stack
	bsr.s	letit
	addq.l	#6,a1		; pop result
	bra.s	let_exit
string
	move.l	bv_bfbas(a6),a0 ; use SuperBASIC's buffer
	move.l	a0,d4
	addq.l	#2,a1		; ignore MSW
	move.w	cn.itod,a2
	jsr	(a2)		; and convert integer to ASCII
	move.l	a1,a4		; keep empty RI stack pointer
*
	move.l	a0,d1		; length of string is...
	sub.l	d4,d1		; ...this much
	move.l	d1,d4		; keep it
	addq.w	#1,d1
	bclr	#0,d1		; even it up
	bne.s	fstack		; it was even, don't adjust
	addq.l	#1,a0		; copy an extra character
fstack
	move.l	d1,d5		; keep evened char count
	addq.l	#2,d1		; allow space for length too
	move.l	a1,bv_rip(a6)
	move.w	bv.chrix,a2		; make sure there's space for it
	jsr	(a2)
	bra.s	copy_end
copy_l
	subq.l	#1,a1
	subq.l	#1,a0
	move.b	0(a6,a0.l),0(a6,a1.l)	; copy character from buffer to RI
copy_end
	dbra	d5,copy_l
	subq.l	#2,a1
	move.w	d4,0(a6,a1.l)	; fill in string length
*
	bsr.s	letit		; assign to variable
	move.l	a4,a1
	bra.s	let_exit
letit
	move.l	a1,bv_rip(a6)
	move.w	bp.let,a2
	jmp	(a2)
*
*	Make a partial save area into a pattern
*
be_mkpat
	move.w	ca.gtlin,a2		; get two addresses
	jsr	(a2)
	bne.s	bem_exit		; whoops
*
	move.l	0(a6,a1.l),a0	; point to header area
	move.l	4(a6,a1.l),a2	; and part save area
	subq.l	#4,a2		; point to link
	move.l	a0,d0
	move.l	a2,d1
	or.l	d1,d0
	ror.b	#1,d0		; do we have an odd address?
	bcs.s	bem_exbp		; yes, naughty
	cmp.w	#ptp.flag,ptp_flag(a2)	; is there a flag on the save area?
	bne.s	bem_exbp		; no, just as bad
*
	move.w	#$100,d0		; assume mode 4
	tst.b	ptp_mode(a2)		; is it?
	beq.s	bem_sfrm		; yes
	addq.w	#1,d0		; no, mode 8
bem_sfrm
	move.w	d0,(a0)+		; fill in form
	clr.w	(a0)+		; no adaption
	move.w	ptp_xsiz(a2),d0 ; get x size = pattern repeat
	and.w	#$fff0,d0		; must be multiple of 16 wide
	move.w	d0,d2		; keep size
	beq.s	bem_exbp		; that's a bit narrow!
	move.w	d0,(a0)+		; fill in x repeat
	move.w	ptp_ysiz(a2),(a0)+	; and y repeat
	beq.s	bem_exbp		; not really tall enough
	clr.l	(a0)+		; no origin
	move.l	#$c,(a0)+		; fill in colour pointer
	clr.l	(a0)+
	clr.l	(a0)+		; no mask or next pointer
*
	lea	ptp_bits(a2),a1 ; point to bit image
	move.w	ptp_rinc(a2),d1 ; this is its row increment
	asr.w	#2,d2		; pattern row is this many bytes
	sub.w	d2,d1		; so skip this far at end of row
	asr.w	#2,d2		; copying this many from each row
	subq.w	#1,d2		; make this OK for DBRA
	move.w	ptp_ysiz(a2),d0 ; row count
	bra.s	bem_cpre
bem_cprl
	move.w	d2,d3		; copy this many longs
bem_cpll
	move.l	(a1)+,(a0)+
	dbra	d3,bem_cpll
	add.w	d1,a1		; skip trash at end of row
bem_cpre
	dbra	d0,bem_cprl
	moveq	#0,d0		; no error 
bem_exit
	rts
bem_exbp
	moveq	#err.ipar,d0
	bra.s	bem_exit
*
	end
